org.eclipse.viatra.integration.uml.derivedfeatures

## Class StructuredClassifierPartMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<StructuredClassifierPartMatch>
    - - org.eclipse.viatra.integration.uml.derivedfeatures.StructuredClassifierPartMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<StructuredClassifierPartMatch>

      public class StructuredClassifierPartMatcher
      extends BaseMatcher<StructuredClassifierPartMatch>

  Generated pattern matcher API of the org.eclipse.viatra.integration.uml.derivedfeatures.structuredClassifierPart pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `StructuredClassifierPartMatch`.

  Original source: ``

       (ownedAttribute- >select(isComposite)- >asSet())

        @Surrogate(feature = "part")
        @QueryExplorer(checked = false)
       pattern structuredClassifierPart(structuredClassifier: StructuredClassifier, part: Property) {
           StructuredClassifier.ownedAttribute(structuredClassifier, part);
           find propertyIsComposite(part, true);
       }

  See Also:
    `StructuredClassifierPartMatch`, `StructuredClassifierPartProcessor`, `StructuredClassifierPartQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected StructuredClassifierPartMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected StructuredClassifierPartMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static StructuredClassifierPartMatcher` | `create()`
    `void` | `forEachMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart, IMatchProcessor<? super StructuredClassifierPartMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart, IMatchProcessor<? super StructuredClassifierPartMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<StructuredClassifierPartMatch>` | `getAllMatches(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<org.eclipse.uml2.uml.Property>` | `getAllValuesOfpart()` Retrieve the set of values that occur in matches for part.
    `java.util.Set<org.eclipse.uml2.uml.Property>` | `getAllValuesOfpart(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier)` Retrieve the set of values that occur in matches for part.
    `java.util.Set<org.eclipse.uml2.uml.Property>` | `getAllValuesOfpart(StructuredClassifierPartMatch partialMatch)` Retrieve the set of values that occur in matches for part.
    `java.util.Set<org.eclipse.uml2.uml.StructuredClassifier>` | `getAllValuesOfstructuredClassifier()` Retrieve the set of values that occur in matches for structuredClassifier.
    `java.util.Set<org.eclipse.uml2.uml.StructuredClassifier>` | `getAllValuesOfstructuredClassifier(org.eclipse.uml2.uml.Property pPart)` Retrieve the set of values that occur in matches for structuredClassifier.
    `java.util.Set<org.eclipse.uml2.uml.StructuredClassifier>` | `getAllValuesOfstructuredClassifier(StructuredClassifierPartMatch partialMatch)` Retrieve the set of values that occur in matches for structuredClassifier.
    `StructuredClassifierPartMatch` | `getOneArbitraryMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `StructuredClassifierPartMatch` | `newMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier, org.eclipse.uml2.uml.Property pPart)` Returns a new (partial) match.
    `static StructuredClassifierPartMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<StructuredClassifierPartMatcher>` | `querySpecification()`
    `protected java.util.Set<org.eclipse.uml2.uml.Property>` | `rawAccumulateAllValuesOfpart(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for part.
    `protected java.util.Set<org.eclipse.uml2.uml.StructuredClassifier>` | `rawAccumulateAllValuesOfstructuredClassifier(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for structuredClassifier.
    `protected StructuredClassifierPartMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static StructuredClassifierPartMatcher on(ViatraQueryEngine engine)
                                                    throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static StructuredClassifierPartMatcher create()
                                                        throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<StructuredClassifierPartMatch> getAllMatches(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                                                                   org.eclipse.uml2.uml.Property pPart)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
      Returns:
        matches represented as a StructuredClassifierPartMatch object.

    - #### getOneArbitraryMatch

          public StructuredClassifierPartMatch getOneArbitraryMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                                                    org.eclipse.uml2.uml.Property pPart)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
      Returns:
        a match represented as a StructuredClassifierPartMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                  org.eclipse.uml2.uml.Property pPart)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                  org.eclipse.uml2.uml.Property pPart)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                   org.eclipse.uml2.uml.Property pPart,
                                   IMatchProcessor<? super StructuredClassifierPartMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                              org.eclipse.uml2.uml.Property pPart,
                                              IMatchProcessor<? super StructuredClassifierPartMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public StructuredClassifierPartMatch newMatch(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier,
                                                        org.eclipse.uml2.uml.Property pPart)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pStructuredClassifier` - the fixed value of pattern parameter structuredClassifier, or null if not bound.
        `pPart` - the fixed value of pattern parameter part, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfstructuredClassifier

          protected java.util.Set<org.eclipse.uml2.uml.StructuredClassifier> rawAccumulateAllValuesOfstructuredClassifier(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for structuredClassifier.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfstructuredClassifier

          public java.util.Set<org.eclipse.uml2.uml.StructuredClassifier> getAllValuesOfstructuredClassifier()

      Retrieve the set of values that occur in matches for structuredClassifier.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfstructuredClassifier

          public java.util.Set<org.eclipse.uml2.uml.StructuredClassifier> getAllValuesOfstructuredClassifier(StructuredClassifierPartMatch partialMatch)

      Retrieve the set of values that occur in matches for structuredClassifier.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfstructuredClassifier

          public java.util.Set<org.eclipse.uml2.uml.StructuredClassifier> getAllValuesOfstructuredClassifier(org.eclipse.uml2.uml.Property pPart)

      Retrieve the set of values that occur in matches for structuredClassifier.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfpart

          protected java.util.Set<org.eclipse.uml2.uml.Property> rawAccumulateAllValuesOfpart(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for part.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpart

          public java.util.Set<org.eclipse.uml2.uml.Property> getAllValuesOfpart()

      Retrieve the set of values that occur in matches for part.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpart

          public java.util.Set<org.eclipse.uml2.uml.Property> getAllValuesOfpart(StructuredClassifierPartMatch partialMatch)

      Retrieve the set of values that occur in matches for part.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfpart

          public java.util.Set<org.eclipse.uml2.uml.Property> getAllValuesOfpart(org.eclipse.uml2.uml.StructuredClassifier pStructuredClassifier)

      Retrieve the set of values that occur in matches for part.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected StructuredClassifierPartMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<StructuredClassifierPartMatch>`

    - #### arrayToMatch

          protected StructuredClassifierPartMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<StructuredClassifierPartMatch>`

    - #### arrayToMatchMutable

          protected StructuredClassifierPartMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<StructuredClassifierPartMatch>`

    - #### querySpecification

          public static IQuerySpecification<StructuredClassifierPartMatcher> querySpecification()
                                                                                         throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded